﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region

'Ctrl + click to export as zip: ide://run?File=%B4X%\Zipper.jar&Args=Project.zip

Sub Class_Globals
	Private Root As B4XView
	Private xui As XUI
	Private Web3Main As Web3X
	Private Utils As W3Utils
	Private InfuraRopstenLink As String = "https://mainnet.infura.io/v3/YOUR_INFURA_ID"
End Sub

Public Sub Initialize
End Sub

Private Sub B4XPage_Created (Root1 As B4XView)
	B4XPages.GetManager.LogEvents = True
	Root = Root1
	Root.LoadLayout("MainPage")
	Utils.Initialize
	Web3Main = Utils.BuildWeb3Infura(InfuraRopstenLink)

	Dim Path As String = "D:\wallet\YOUR_WALLET.json"
	Wait For (Utils.LoadWallet(Path, "YOUR_PASS")) Complete (Result As W3AsyncResult)
	If Result.Success Then
		Dim Credentials As W3Credentials = Result.Value
		Log(Credentials.Address)
	End If
	
	Dim ToAddress As String = "0x123SDASD32DASDASdadas3adsa"
	Dim Amount As BigInteger = Utils.BigIntFromUnit("0.01", "ether")
	Dim MaxPriorityFeePerGas As BigInteger = Utils.BigIntFromUnit("3", "gwei")
	Dim MaxFeePerGas As BigInteger = Utils.BigIntFromUnit("200", "gwei")
	Dim ChainId As Int = Utils.CHAINID_MAINNET
	Log("bp1 ")
	Wait For (Web3Main.SendFunds(ChainId, Credentials, ToAddress, Amount, MaxPriorityFeePerGas, MaxFeePerGas)) Complete (Result As W3AsyncResult)
	Log("bp3 = "&Result)
	If Result.Success Then
		Dim hash As W3TransactionHash = Result.Value
		Log("Transaction sent successfully: ")
		Log(hash.Hash)
		Dim Timeout As Int = 300 'seconds
		Wait For (Web3Main.EthGetTransactionReceipt(hash, Timeout)) Complete (Result As W3AsyncResult)
		If Result.Success Then
			Dim tr As W3TransactionReceipt = Result.Value
			If tr.Pending Then
				Log("Transaction still pending")
			Else
				Log("Transaction completed, ok? " & tr.StatusOk)
				Log(tr)
			End If
		Else
			Log("Error getting receipt: " & Result.Error)
		End If
	Else
		Log("meucu 2")
	End If

End Sub